#include "mbed.h"
#include "time.h"
#include "Motor.h"

AnalogIn ain(p19);
Serial pc(USBTX, USBRX);
Timer t;
Motor m(p25,p27,p28);

float height;

float Lower_distance = 7; // lower floor in inches.

float Upper_distance = 22; // upper floor in inches

float Desired_distance = Upper_distance;  // start low
float err;

int time_count = 0;
int main()

{
    pc.baud(9600);
    pc.format(7,SerialBase::None,1);
    t.reset();  //reset timer to zero
    t.start();  //start timer data timestamp

    while(1) {
        while(time_count<300) {

            height = 193.125176919012*(pow(ain.read(),3))-353.927724612106*(pow(ain.read(),2))+218.749286479109*(ain.read())-23.2532105680997;



            pc.printf("%f,",ain.read()); //this prints the voltage
            pc.printf("%f,",height);
            pc.printf("%f",t.read());
            pc.printf("\n\r");

            if(height < Desired_distance) {
                
                m.speed(0.7);
            } else if(height > Desired_distance) {
                
                m.speed(-0.7);
            } else if(height==Desired_distance) {
                
                m.speed(0.0);
            }

            time_count = time_count+1;
        }
        if (height == Desired_distance)
        {
            Desired_distance = Lower_distance;
             if(height < Desired_distance) {
                
                m.speed(0.7);
            } else if(height > Desired_distance) {
                
                m.speed(-0.7);
            } else if(height==Desired_distance) {
                
                m.speed(0.0);
            }
        }
    }
}